#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <getopt.h>
#include "crack.h"

char  *inc_msg;

int           verbose = 0;

void
usage( char *progname )
{
  fprintf( stderr, "\n%s [options] [top_directory]\n", progname );
  fprintf( stderr, "\t-p\tpatch (otherwise dry run only)\n" );
  fprintf( stderr, "\t-r\treverse patch\n" );
  fprintf( stderr, "\t-v\tincrease verbosity level\n" );
  fputc( '\n', stderr );
}

int
main( int argc, char *argv[] )
{
  char         *top_directory;
  int           option;

  dry_run = 1;
  printf( "\n%s - %s\n\n", TITLE, AUTHOR );
  printf( "Verified to work with the following versions:\n%s\n"
	  "other versions may also work\n\n", VERIFIED );
  do
  {
    option = getopt( argc, argv, "vpr" );
    switch ( option )
    {
      case 'v':
	verbose++;
	break;
      case 'p':
	dry_run = 0;
	break;
      case 'r':
	reverse_patch = 1;
	break;
      case EOF:		// no more options
	break;
      default:
	fprintf( stderr, "getopt returned impossible value: %d ('%c')",
	    option, option );
    }
  }
  while ( option != EOF );
  usage( argv[0] );

  if ( optind == argc )
    top_directory = ".";
  else
    top_directory = argv[optind++];

  flow( top_directory );
  exit( 0 );
}
